VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mobjAcc95 As Object
Private mobjAcc97 As Object

Private mfrmOrig As Object
Private mfrmCopy As Object

Private Type tEvents
    stControl As String
    stEvent As String
    stValue As String
End Type

Private Type tProp
    strPropName As String
    intPropType As Integer
    varPropValue As String
    blnInherited As Boolean
End Type

Private Type tControl
    strControlName As String
    intControlType As Integer
    intSection As Integer
    atProps() As tProp
End Type

Private Type tForm
    strFormName As String
    atProps() As tProp
End Type

Private Type tSection
    intSection As Integer
    strName As String
    atProps() As tProp
End Type

Private mtEvents() As tEvents
Private mtCtl() As tControl
Private mtFrm As tForm
Private matSection() As tSection

Private mcolBadProperty As Collection
Private mobjAcc As Object
Private mintErrorTrap As Integer
Private mstrForm As String
Private mfrmStatus As Form
Private mcolEvents As Collection

Private Sub Class_Initialize()
    Set mcolEvents = New Collection
    Set mcolBadProperty = New Collection
    With mcolBadProperty
        .Add Item:="TextFontCharset", Key:="TextFontCharset"
        .Add Item:="|", Key:="|"
        .Add Item:="HyperlinkAddress", Key:="HyperlinkAddress"
        .Add Item:="HyperlinkSubAddress", Key:="HyperlinkSubAddress"
    End With
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    mobjAcc95.DoCmd.Save AcObjectType.acForm, mfrmCopy.Name
    mobjAcc95.DoCmd.Close AcObjectType.acForm, mfrmCopy.Name
    mobjAcc97.DoCmd.Close AcObjectType.acForm, mfrmOrig.Name, AcCloseSave.acSaveNo
    Erase matSection
    Erase mtEvents
    Erase mtCtl
    Set mcolBadProperty = Nothing
    Set mcolEvents = Nothing
    Set mfrmOrig = Nothing
    Set mfrmCopy = Nothing
End Sub

Public Property Let SetSourceForm(strfrm As String)
    Erase matSection
    Erase mtEvents
    Erase mtCtl
    Erase mtFrm.atProps
    mobjAcc97.DoCmd.OpenForm strfrm, AcFormView.acDesign
    Set mfrmOrig = mobjAcc97.Forms(strfrm)
    Set mfrmCopy = Nothing
End Property

Public Sub SaveForm()
    mobjAcc95.DoCmd.Save AcObjectType.acForm, mfrmCopy.Name
    mobjAcc95.DoCmd.Close AcObjectType.acForm, mfrmCopy.Name
    mobjAcc97.DoCmd.Close AcObjectType.acForm, mfrmOrig.Name, AcCloseSave.acSaveNo
End Sub
Public Property Set SetAcc95Instance(objAcc95 As Object)
    Set mobjAcc95 = objAcc95
End Property

Public Property Set SetAccess97Instance(objAcc97 As Object)
    Set mobjAcc97 = objAcc97
End Property

Public Sub CopyForm()
Dim ctlOrig As Object
Dim ctlCopy As Object
Dim secOrig As Object
Dim blnCreateSection As Boolean
Dim prpSec As Property
Dim prpCtl As Property
Dim prpFrm As Property
Dim intX As Integer
Dim intCtlCount As Integer
Dim intY As Integer
Dim intPrpCount As Integer
Dim strName As String
    On Error Resume Next
    
    With mobjAcc95
        Set mfrmCopy = mobjAcc95.CreateForm
        
        'Get Form properties
        With mtFrm
            .strFormName = mfrmOrig.Name
            intCtlCount = mfrmOrig.Properties.Count
            With frmStatus
                .Activate
                .ClearSubProgressBar
                .SubInterval = 1
                .SetSubScaleWidth = intCtlCount
            End With
            ReDim .atProps(intCtlCount)
            For intX = 0 To intCtlCount - 1
                Call sUpdateSubMeter("Reading Form " & pconQ & .strFormName & pconQ)
                Set prpFrm = mfrmOrig.Properties(intX)
                .atProps(intX).strPropName = prpFrm.Name
                .atProps(intX).blnInherited = prpFrm.Inherited
                .atProps(intX).varPropValue = prpFrm.Value
                .atProps(intX).intPropType = prpFrm.Type
            Next
        End With
        
        With frmStatus
            .ClearSubProgressBar
            .SetSubCaption = "Adjusting form sections...."
            .Refresh
        End With
        
        'Adjust the form sections
        Call sAdjustFormSections
    
        'Store Original form's properties
        With mfrmOrig
            intCtlCount = .Controls.Count
            ReDim mtCtl(intCtlCount)
            With frmStatus
                .Activate
                .SubInterval = 1
                intX = UBound(mtCtl) * 2
                If intX = 0 Then
                    .SetSubScaleWidth = 1
                Else
                    .SetSubScaleWidth = intX
                End If
            End With
            For intX = 0 To intCtlCount - 1
                Set ctlOrig = .Controls(intX)
                'skip over TabControl and Pages
                If Not fIsBadControl(ctlOrig.controlType) Then
                    mtCtl(intX).strControlName = ctlOrig.Name
                    mtCtl(intX).intControlType = ctlOrig.controlType
                    mtCtl(intX).intSection = ctlOrig.Section
                    intPrpCount = ctlOrig.Properties.Count
                    ReDim Preserve mtCtl(intX).atProps(intPrpCount)
                    Call sUpdateSubMeter("Reading Control " & pconQ & mtCtl(intX).strControlName & pconQ)
                    For intY = 0 To intPrpCount - 1
                        Set prpCtl = ctlOrig.Properties(intY)
                        If Not fIsBadProperty(prpCtl.Name) Then
                            With mtCtl(intX)
                                .atProps(intY).strPropName = prpCtl.Name
                                .atProps(intY).blnInherited = prpCtl.Inherited
                                .atProps(intY).varPropValue = prpCtl.Value
                                .atProps(intY).intPropType = prpCtl.Type
                            End With
                        End If
                    Next
                End If
            Next
        End With
        
        With frmStatus
            .SetSubCaption = "Saving the form...."
            .Refresh
        End With
        
        'rename the new form
        strName = mfrmCopy.Name
        .DoCmd.SelectObject AcObjectType.acForm, strName, False
        .DoCmd.Save AcObjectType.acForm, strName
        .DoCmd.Close AcObjectType.acForm, strName
        .DoCmd.SelectObject AcObjectType.acForm, strName, True
        .DoCmd.Rename mtFrm.strFormName, AcObjectType.acForm, strName
        .DoCmd.OpenForm mtFrm.strFormName, AcFormView.acDesign
        Set mfrmCopy = mobjAcc95.Forms(mtFrm.strFormName)
        
        With frmStatus
            .SetSubCaption = "Assigning form properties...."
            .Refresh
        End With
        
        'Assign all the properties back to this new form
        With mtFrm
            For intX = 0 To UBound(.atProps) - 1
                mfrmCopy.Properties(.atProps(intX).strPropName).Value = _
                        .atProps(intX).varPropValue
            Next
        End With
        
        'Now create the control
        With mfrmCopy
            For intX = 0 To UBound(mtCtl) - 1
                Call sUpdateSubMeter("Creating Control " & pconQ & mtCtl(intX).strControlName & pconQ)
                With mtCtl(intX)
                    Set ctlCopy = mobjAcc95.CreateControl(mtFrm.strFormName, .intControlType, .intSection)
                    For intY = 0 To UBound(.atProps)
                        ctlCopy.Properties(.atProps(intY).strPropName).Value = .atProps(intY).varPropValue
                    Next
                End With

                If ctlOrig.controlType = AcControlType.acObjectFrame Then
                    ctlCopy.OleData = ctlOrig.OleData
                End If
            Next
        End With
    End With
    
    'Now copy the code
    Call sCopyCBF
                
    On Error GoTo 0
    Set ctlOrig = Nothing
    Set ctlCopy = Nothing
    Set secOrig = Nothing
    Set prpSec = Nothing
    Set prpCtl = Nothing
    Set prpFrm = Nothing
End Sub

Private Function fIsBadControl(intControlType As Integer) As Boolean
    If intControlType = AcControlType.acPage Or _
            intControlType = AcControlType.acTabCtl Then
                fIsBadControl = True
    End If
End Function

Private Function fIsBadProperty(strProp As String) As Boolean
Dim i As Integer
Dim blnBad As Boolean
    For i = 1 To mcolBadProperty.Count
        If UCase(strProp) = UCase(mcolBadProperty.Item(i)) Then
            blnBad = True
            Exit For
        End If
    Next
    fIsBadProperty = blnBad
End Function

Private Sub sUpdateSubMeter(strText As String)
    With frmStatus
        .UpdateSubText = strText
        .SubIncrement
        .Refresh
    End With
End Sub

Private Sub sCopyCBF()
Dim ctl As Control, prop As Property
Dim intDimension As Integer
Dim objMdl As Object
Dim objNewMdl As Object
Dim strCode As String
Dim i As Integer
Dim j As Integer
Dim intMaxLines As Integer
Dim strNewMdl As String

    With mfrmOrig
        If .HasModule Then
            With frmStatus
                .ClearSubProgressBar
                .SetSubCaption = "Copying associated code...."
                .Refresh
            End With
            With mobjAcc97.DoCmd
                'Grab the code.
                'Custom functions and macros placed OnEvents
                'are already read in through properties.
                '
                .SelectObject AcObjectType.acForm, mfrmOrig.Name
                .RunCommand AcCommand.acCmdViewCode
                Set objMdl = mobjAcc97.Modules(mfrmOrig.Module)
                
                intMaxLines = 1
                i = 1
                Do While i <= objMdl.CountOfLines
                    strCode = objMdl.lines(i, intMaxLines)
                    If InStr(strCode, "Option Compare Database") > 0 Or _
                            InStr(strCode, "Option Explicit") > 0 Then
                        i = i + 1
                        strCode = objMdl.lines(i, intMaxLines)
                        If InStr(strCode, "Option Compare Database") > 0 Or _
                            InStr(strCode, "Option Explicit") > 0 Then
                            i = i + 1
                            intMaxLines = 10
                            strCode = objMdl.lines(i, intMaxLines)
                        End If
                    End If
                    If Right$(strCode, 1) = "_" Then
                        j = 1
                        Do While Right$(strCode, 1) = "_"
                            strCode = objMdl.lines(i, intMaxLines + j)
                            j = j + 1
                        Loop
                        i = i + j
                    End If
                    mobjAcc95.Forms(mfrmCopy.Name).Module.InsertText strCode
                    i = i + intMaxLines
                Loop
                Set objMdl = Nothing
            End With
        End If
    End With
End Sub

Private Sub sAdjustFormSections()
Dim intTmp As Integer
Dim varTmp As Variant
Dim blnFormHdrFtr As Boolean
Dim blnPageHdrFtr As Boolean
Dim intI As Integer
Dim intJ As Integer
Dim sec As Object
Dim prp As Object
Dim strCopyName As String
Dim strOrigName As String

    On Error Resume Next
    varTmp = mfrmOrig.Section(AcSection.acHeader).Name
    If Err.Number = 0 Then blnFormHdrFtr = True
    
    varTmp = mfrmOrig.Section(AcSection.acPageHeader).Name
    If Err.Number = 0 Then blnPageHdrFtr = True
    
    strCopyName = mfrmCopy.Name
    strOrigName = mfrmOrig.Name
    
    If blnFormHdrFtr Then
        With mobjAcc95
            .DoCmd.SelectObject AcObjectType.acForm, strCopyName, False
            .DoCmd.DoMenuItem 3, 2, 11, 0, AcVersion.acMenuVer70
        End With
    End If
    
    If blnPageHdrFtr Then
        With mobjAcc95
            .DoCmd.SelectObject AcObjectType.acForm, strCopyName, False
            .DoCmd.DoMenuItem 3, 2, 10, 0, AcVersion.acMenuVer70
        End With
    End If
    
    intI = 0
    intTmp = 0
    Err.Clear
    Do While intI <= 8
        With mfrmOrig
            Set sec = .Section(intI)
            If Err.Number = 0 Then
                ReDim Preserve matSection(intTmp)
                matSection(intTmp).intSection = intTmp
                matSection(intTmp).strName = sec.Name
                ReDim Preserve matSection(intTmp).atProps(sec.Properties.Count)
                For intJ = 0 To sec.Properties.Count - 1
                    Set prp = sec.Properties(intJ)
                    matSection(intTmp).atProps(intJ).strPropName = prp.Name
                    matSection(intTmp).atProps(intJ).varPropValue = prp.Value
                Next
                intTmp = intTmp + 1
            End If
        End With
        intI = intI + 1
    Loop
    
    With mfrmCopy
        For intI = 0 To UBound(matSection)
            Set sec = .Section(matSection(intI).intSection)
            sec.Name = matSection(intI).strName
            For intJ = 0 To UBound(matSection(intI).atProps)
                sec.Properties(matSection(intI).atProps(intJ).strPropName) = _
                    matSection(intI).atProps(intJ).varPropValue
            Next
        Next
    End With
End Sub
