VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cReport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type tProp
    strPropName As String
    intPropType As Integer
    varPropValue As String
    blnInherited As Boolean
End Type

Private Type tEvents
    stControl As String
    stEvent As String
    stValue As String
End Type

Private Type tControl
    strControlName As String
    intControlType As Integer
    intSection As Integer
    atProps() As tProp
End Type

Private Type tGroupInfo
    intSection As Integer
    strControlSource As String
    intGroupHeader As Integer
    intGroupFooter As Integer
    atProps() As tProp
End Type

Private Type tSection
    intSection As Integer
    strName As String
    atProps() As tProp
End Type

Private Type tReport
    strReportName As String
    atProps() As tProp
End Type


Private mobjAcc95 As Object
Private mobjAcc97 As Object
Private mtEvents() As tEvents
Private mtCtl() As tControl
Private mtRpt As tReport
Private mfrmStatus As Form
Private matGrpInfo() As tGroupInfo
Private matSection() As tSection
Private mrptOrig As Object
Private mrptCopy As Object
Private mblnRptHdrFtr As Boolean

Private Sub Class_Terminate()
    On Error Resume Next
    mobjAcc95.DoCmd.Save AcObjectType.acReport, mrptCopy.Name
    mobjAcc95.DoCmd.Close AcObjectType.acReport, mrptCopy.Name
    mobjAcc97.DoCmd.Close AcObjectType.acReport, mrptOrig.Name, AcCloseSave.acSaveNo
    Erase mtCtl
    Erase matGrpInfo
    Erase matSection
    Erase mtEvents
    Set mrptOrig = Nothing
    Set mrptCopy = Nothing
End Sub

Public Property Set SetAcc95Instance(objAcc95 As Object)
    Set mobjAcc95 = objAcc95
End Property

Public Property Set SetAccess97Instance(objAcc97 As Object)
    Set mobjAcc97 = objAcc97
End Property

Public Property Let SetSourceReport(strRpt As String)
    Erase mtCtl
    Erase matGrpInfo
    Erase matSection
    Erase mtEvents
   
    mobjAcc97.DoCmd.OpenReport strRpt, AcReportView.acDesign
    Set mrptOrig = mobjAcc97.Reports(strRpt)
    Set mrptCopy = Nothing
End Property

Public Sub SaveReport()
    mobjAcc95.DoCmd.Save AcObjectType.acReport, mrptCopy.Name
    mobjAcc95.DoCmd.Close AcObjectType.acReport, mrptCopy.Name
    mobjAcc97.DoCmd.Close AcObjectType.acReport, mrptOrig.Name, AcCloseSave.acSaveNo
End Sub

Public Sub CopyReport()
Dim ctlOrig As Object
Dim ctlCopy As Object
Dim secOrig As Object
Dim blnCreateSection As Boolean
Dim prpSec As Property
Dim prpCtl As Property
Dim prpRpt As Property
Dim intX As Integer
Dim intCtlCount As Integer
Dim intY As Integer
Dim intPrpCount As Integer
Dim strName As String
    
    On Error Resume Next
    With mobjAcc95
        Set mrptCopy = mobjAcc95.CreateReport
        
        'Get Report properties
        With mtRpt
            .strReportName = mrptOrig.Name
            intCtlCount = mrptOrig.Properties.Count
            With frmStatus
                .Activate
                .ClearSubProgressBar
                .SubInterval = 1
                .SetSubScaleWidth = intCtlCount
            End With
            
            ReDim .atProps(intCtlCount)
            For intX = 0 To intCtlCount - 1
                Call sUpdateSubMeter("Reading Report " & _
                                    pconQ & .strReportName & pconQ)
                Set prpRpt = mrptOrig.Properties(intX)
                .atProps(intX).strPropName = prpRpt.Name
                .atProps(intX).blnInherited = prpRpt.Inherited
                .atProps(intX).varPropValue = prpRpt.Value
                .atProps(intX).intPropType = prpRpt.Type
            Next
        End With
        
        'Adjust the Report sections
        With frmStatus
            .ClearSubProgressBar
            .SetSubCaption = "Adjusting report sections...."
            .Refresh
        End With
        Call sReportSections
    
        'Store Original Report's properties
        With mrptOrig
            intCtlCount = .Controls.Count
            ReDim mtCtl(intCtlCount)
            With frmStatus
                .Activate
                .SubInterval = 1
                .SetSubScaleWidth = UBound(mtCtl) * 2
            End With
            
            For intX = 0 To intCtlCount - 1
                Set ctlOrig = .Controls(intX)
                mtCtl(intX).strControlName = ctlOrig.Name
                mtCtl(intX).intControlType = ctlOrig.controlType
                mtCtl(intX).intSection = ctlOrig.Section
                intPrpCount = ctlOrig.Properties.Count
                ReDim Preserve mtCtl(intX).atProps(intPrpCount)
                Call sUpdateSubMeter("Reading Control " & _
                        pconQ & mtCtl(intX).strControlName & pconQ)
                For intY = 0 To intPrpCount - 1
                    Set prpCtl = ctlOrig.Properties(intY)
                    With mtCtl(intX)
                        .atProps(intY).strPropName = prpCtl.Name
                        .atProps(intY).blnInherited = prpCtl.Inherited
                        .atProps(intY).varPropValue = prpCtl.Value
                        .atProps(intY).intPropType = prpCtl.Type
                    End With
                Next
            Next
        End With
        
        With frmStatus
            .SetSubCaption = "Saving the report...."
            .Refresh
        End With
        
        'rename the new Report
        strName = mrptCopy.Name
        .DoCmd.SelectObject AcObjectType.acReport, strName, False
        .DoCmd.Save AcObjectType.acReport, strName
        .DoCmd.Close AcObjectType.acReport, strName
        .DoCmd.SelectObject AcObjectType.acReport, strName, True
        .DoCmd.Rename mtRpt.strReportName, AcObjectType.acReport, strName
        .DoCmd.OpenReport mtRpt.strReportName, AcReportView.acDesign
        Set mrptCopy = mobjAcc95.Reports(mtRpt.strReportName)
        
        'Assign all the properties back to this new Report
        With frmStatus
            .SetSubCaption = "Assigning report properties...."
            .Refresh
        End With
        
        With mtRpt
            For intX = 0 To UBound(.atProps) - 1
                mrptCopy.Properties(.atProps(intX).strPropName).Value = _
                        .atProps(intX).varPropValue
            Next
        End With
        
        'Now create the control
        With mrptCopy
            For intX = 0 To UBound(mtCtl) - 1
                Call sUpdateSubMeter("Creating Control " & _
                        pconQ & mtCtl(intX).strControlName & pconQ)
                With mtCtl(intX)
                    Set ctlCopy = mobjAcc95.CreateReportControl( _
                                        mtRpt.strReportName, _
                                        .intControlType, _
                                        .intSection)
                                        
                    For intY = 0 To UBound(.atProps)
                        ctlCopy.Properties(.atProps(intY).strPropName).Value = _
                                        .atProps(intY).varPropValue
                    Next
                End With

                If ctlOrig.controlType = AcControlType.acObjectFrame Then
                    ctlCopy.OleData = ctlOrig.OleData
                End If
            Next
        End With
    End With
    
    'Now copy the code
    Call sCopyCBR
                
    Set ctlOrig = Nothing
    Set ctlCopy = Nothing
    Set secOrig = Nothing
    Set prpSec = Nothing
    Set prpCtl = Nothing
    Set prpRpt = Nothing
End Sub
    
    
Private Sub sCopyCBR()
Dim intDimension As Integer
Dim objMdl As Object
Dim objNewMdl As Object
Dim strCode As String
Dim i As Integer
Dim j As Integer
Dim intMaxLines As Integer
Dim strNewMdl As String

    With mrptOrig
        If .HasModule Then
            With frmStatus
                .ClearSubProgressBar
                .SetSubCaption = "Copying associated code...."
                .Refresh
            End With
            With mobjAcc97.DoCmd
                'Grab the code.
                'Custom functions and macros placed OnEvents
                'are already read in through properties.
                '
                .SelectObject AcObjectType.acReport, mrptOrig.Name
                .RunCommand AcCommand.acCmdViewCode
                Set objMdl = mobjAcc97.Modules(mrptOrig.Module)
                
                intMaxLines = 1
                i = 1
                Do While i <= objMdl.CountOfLines
                    strCode = objMdl.lines(i, intMaxLines)
                    If InStr(strCode, "Option Compare Database") > 0 Or _
                            InStr(strCode, "Option Explicit") > 0 Then
                        i = i + 1
                        strCode = objMdl.lines(i, intMaxLines)
                        If InStr(strCode, "Option Compare Database") > 0 Or _
                            InStr(strCode, "Option Explicit") > 0 Then
                            i = i + 1
                            intMaxLines = 10
                            strCode = objMdl.lines(i, intMaxLines)
                        End If
                    End If
                    If Right$(strCode, 1) = "_" Then
                        j = 1
                        Do While Right$(strCode, 1) = "_"
                            strCode = objMdl.lines(i, intMaxLines + j)
                            j = j + 1
                        Loop
                        i = i + j
                    End If
                    mobjAcc95.Reports(mrptCopy.Name).Module.InsertText strCode
                    i = i + intMaxLines
                Loop
                Set objMdl = Nothing
            End With
        End If
    End With
End Sub

Private Sub sReportSections()
Dim strOrigName As String
Dim strCopyName As String
Dim sec As Object
Dim intI As Integer
Dim intJ As Integer
Dim prp As Object
Dim grpOrig As Object
Dim grpCopy As Object
Dim varGrpCopy As Variant
Dim intTmp As Integer
Dim dblHeight As Double
Dim tRpt As tReport
Const conMAXGROUPS = 9

    On Error Resume Next
    intI = 0
    strOrigName = mrptOrig.Name
    strCopyName = mrptCopy.Name
    
    'Determine whether the report has header/footer
    intTmp = mrptOrig.Section(AcSection.acHeader).Visible
    If Err.Number = 0 Then mblnRptHdrFtr = True
    
    'Store group level info
    Do While intI <= conMAXGROUPS
        Set grpOrig = mrptOrig.GroupLevel(intI)
        If Err.Number <> 0 Then Exit Do
        ReDim Preserve matGrpInfo(intI)
        With matGrpInfo(intI)
            .intSection = intI
            .intGroupFooter = grpOrig.GroupFooter
            .intGroupHeader = grpOrig.GroupHeader
            .strControlSource = grpOrig.ControlSource
            ReDim Preserve .atProps(grpOrig.Properties.Count - 1)
            For intJ = 0 To UBound(.atProps) - 1
                Set prp = grpOrig.Properties(intJ)
                .atProps(intJ).strPropName = prp.Name
                .atProps(intJ).varPropValue = prp.Value
            Next
        End With
        intI = intI + 1
    Loop
    
    'read all Report properties
    tRpt.strReportName = strOrigName
    ReDim Preserve tRpt.atProps(mrptOrig.Properties.Count - 1)
    With mrptOrig
        For intI = 0 To UBound(tRpt.atProps)
            Set prp = .Properties(intI)
            tRpt.atProps(intI).strPropName = prp.Name
            tRpt.atProps(intI).varPropValue = prp.Value
        Next
    End With
    
    'All section properties
    intI = 0
    intTmp = 0
    Err.Clear
    Do While intI <= 8
        With mrptOrig
            Set sec = .Section(intI)
            If Err.Number = 0 Then
                ReDim Preserve matSection(intTmp)
                matSection(intTmp).intSection = intTmp
                matSection(intTmp).strName = sec.Name
                ReDim Preserve matSection(intTmp).atProps(sec.Properties.Count)
                For intJ = 0 To sec.Properties.Count - 1
                    Set prp = sec.Properties(intJ)
                    matSection(intTmp).atProps(intJ).strPropName = prp.Name
                    matSection(intTmp).atProps(intJ).varPropValue = prp.Value
                Next
                intTmp = intTmp + 1
            End If
        End With
        intI = intI + 1
    Loop
    
    'Create groups, first displaying the header/footer
    If mblnRptHdrFtr Then
        With mobjAcc95
            .DoCmd.SelectObject AcObjectType.acReport, strCopyName, False
            .DoCmd.DoMenuItem 7, 2, 11, 0, AcVersion.acMenuVer70
        End With
    End If
    
    For intI = 0 To UBound(matGrpInfo)
        With matGrpInfo(intI)
            varGrpCopy = mobjAcc95.CreateGroupLevel( _
                            strCopyName, _
                            .strControlSource, _
                            .intGroupHeader, _
                            .intGroupFooter)
            Set grpCopy = mrptCopy.GroupLevel(intI)
            For intJ = 0 To UBound(.atProps) - 1
                grpCopy.Properties(.atProps(intJ).strPropName) = _
                        .atProps(intJ).varPropValue
            Next
        End With
    Next

    'Assign Report Properties
    With mrptCopy
        For intI = 0 To UBound(tRpt.atProps)
            .Properties(tRpt.atProps(intI).strPropName) = _
                tRpt.atProps(intI).varPropValue
        Next
    End With

    'Assign section properties
    With mrptCopy
        For intI = 0 To UBound(matSection)
            Set sec = .Section(matSection(intI).intSection)
            sec.Name = matSection(intI).strName
            For intJ = 0 To UBound(matSection(intI).atProps)
                sec.Properties(matSection(intI).atProps(intJ).strPropName) = _
                    matSection(intI).atProps(intJ).varPropValue
            Next
        Next
    End With
End Sub


Private Sub sUpdateSubMeter(strText As String)
    With frmStatus
        .UpdateSubText = strText
        .SubIncrement
        .Refresh
    End With
End Sub

